<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\ReadRequest;
use Exception;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\View\View;

use App\User;
use App\Read;
use App\Device;

use App\Notification;
class ReadController extends Controller
{
    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/reads';
    /** View folder */
    private $viewDirectory= 'admin.reads.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('reads.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the reads.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query = Read::orderBy('id', 'DESC');

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('name', 'LIKE', '%'.$request->name.'%');
        }


        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $reads= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('reads'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('reads.store');
        $head = metaFields('reads', 'add_new', getCurrentLocale()) ?? __('reads.new');
        $users = User::cursor();
        $devices = Device::cursor();
        return view( $this->viewDirectory.'form', compact('action', 'head','users','devices') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param ReadRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(ReadRequest $request) :RedirectResponse
    { 
        $data = $request->read;
        foreach($data as $row){
        Read::create([
            'user_id'=>$request->user_id,
            'device_id'=>$row['device_id'],
            'number'=>$row['number']
            ]);
        }
       
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  Read  $read
     * @return View
     */
    public function edit(Read $read): View
    {
        $action= route('reads.update', $read->id);
        $head = metaFields('reads', 'edit', getCurrentLocale()) ?? __('reads.edit');
        $users = User::cursor();
        $devices = Device::cursor();

        return view( $this->viewDirectory.'form', compact('read', 'action', 'head','users','devices') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  ReadRequest  $request
     * @param  Read  $systemfood
     * @return RedirectResponse|Redirector
     */
        public function update(ReadRequest $request, Read $read) :RedirectResponse
    {
     
       
        $read->update($request->all());
        
        

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }
    private function saveData(ReadRequest $request, int $read_id ):void
    {
        
      

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $user = Read::withTrashed()->find($id);
        if ($user) {
            if ($user->deleted_at) {
                $user->forceDelete();
            } else {
                $user->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            Read::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            Read::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $user = Read::withTrashed()->find($id);

        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $user = Read::whereIn('id', $request->ids)->onlyTrashed();
        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
